const std = @import("std");

pub fn main() !void {
    const stdout_file = std.io.getStdOut().writer();
    var bw = std.io.bufferedWriter(stdout_file);
    const stdout = bw.writer();

    const total_attempts: i32 = 256 * 256 * 256;
    var successful_attempts: i32 = 0;

    for (0..256) |a| {
        for (0..256) |b| {
            for (0..256) |c| {
                if (a + b + c > 300) {
                    successful_attempts += 1;
                }
            }
        }
    }

    // const probability = @as(f32, @floatFromInt(successful_attempts)) / @as(f32, @floatFromInt(total_attempts));

    try stdout.print("Iterations: {}\n", .{total_attempts});
    try stdout.print("Valid sums: {}\n", .{successful_attempts});
    try stdout.print("Probability: {d:.7}\n", .{@as(f32, @floatFromInt(successful_attempts)) / @as(f32, @floatFromInt(total_attempts))});

    try bw.flush(); // don't forget to flush!
}
